component-section
  div(slot='title') Studiehandleiding
  component-section
    div(slot='title') Inleiding
    p
      | Van vaklui tot gebruikers: iedereen heeft een mening over de
      |
      em prestatie-efficiëntie
      |
      | (performance efficiency) van software.
      | Hoe kan het dat populaire software soms toch niet vooruit te branden is?
      | Komt het door (verkeerde?) ontwerpbeslissingen op een hoog abstractieniveau, is the devil in the details, of ligt het aan iets anders?
      | Jij bent een freelance softwarearchitectuurconsultant, en jij gaat de uitdaging aan om dit probleem op te lossen voor een bepaald softwaresysteem.
    p
      | In Onderzoek naar performance leer en beoefen je vaardigheden waarover je kennis hebt opgedaan in SKA en ADP.
    component-section
      div(slot='title') Professioneel werken in je eigen omgeving
      p
        | Het ASD-docententeam wil dat ASD goed aansluit bij de behoeftes op jouw werk en/of bij je vakinteresses.
        | De opdracht is voor een belangrijk deel vrij in te vullen.
        | Je werkt zelfstandig en zoals in het echt.
        | Deze opdracht is met andere woorden een
        |
        em werkplekopdracht
        | .
    component-section
      div(slot='title') Softwarearchitectuur + algoritmes en datastructuren = softwarekwaliteit?
      p
        | 🏛️ Softwarearchitectuur in samenhang bekijken met 🧮 algoritmes en datastructuren is extra leerzaam.
        | SKA en ADP gaan over twee ogenschijnlijk ver van elkaar staande kennisgebieden, maar in ASD leer je gaandeweg dat je beide prima kunt integreren om efficiëntere en effectievere softwaresystemen op te leveren.
        | ✅ Softwarekwaliteit vormt de brug tussen SKA en ADP.
  component-section
    div(slot='title') Toetsen
    include ../toetsstructuur.pug
    component-section
      div(slot='title')
        | Presentatie over je keuze van softwaresysteem voor het onderzoek (
        code Ass_Pres
        | )
      component-section
        div(slot='title') Doel
        p
          | Presenteer maximaal tien minuten over het softwaresysteem dat je gaat onderzoeken.
        p
          | Het softwaresysteem moet voldoen aan een aantal criteria ten aanzien van onder andere kwaliteit en schaal.
          | Maar los daarvan, begin je natuurlijk vanuit de behoefte van je opdrachtgever.
          | Waarom is performance relevant voor dit systeem?
          | En dan specifiek voor bepaalde use-cases?
        p
          | In het beoordelingsformulier staan een aantal vormcriteria.
          | De 10 000 regels kan je meten broncode met
          |
          a(href='https://github.com/XAMPPRocky/tokei') Tokei
          | .
          | Let erop dat de ontwikkeling van het systeem kwalitatief goed uitgevoerd is, en dat het systeem ook nu nog onderhouden wordt.
          | De productkwaliteit kan je onder meer afleiden uit het voldoen aan onder andere de OOSE-richtlijnen, en/of bijvoorbeeld de aanwezigheid van een degelijke geautomatiseerde test suite, API-/commentaardocumentatie en een uniforme broncodestijl.
        p
          | Er zijn ook criteria wat betreft je communicatie met belanghebbenden en in hoeverre je aantoont dat zij waarde hechten aan je onderzoek.
          | Ga zo snel mogelijk na welke informatie je bijvoorbeeld met bijvoorbeeld
          |
          a(href='https://onderzoek.hbo-i.nl/index.php/Interview') interviews
          |
          | nog moet ophalen bij deze belanghebbenden.
          | Als je andere betrouwbare bronnen hebt die je methodisch gebruikt, kan je de benodigde communicatie met de belanghebbenden vast wel beperken.
          | In de praktijk verwachten je beoordelaars dat je vooral navraag moet doen bij belanghebbenden als het gaat om de
          |
          em inhoud van de performance-qar’s
          | . ‘Hoe snel moet het zijn?’
          | Wat jij voor vereisten in gedachten hebt, hoeft niet de bedoeling van opdrachtgever, architect of andere belanghebbenden te zijn geweest.
        p
          strong 💡 1
          | : Hoe zorgvuldig en snel je kiest heeft grote invloed op je kans van slagen voor OP.
        p
          strong 💡 2
          | : Vermijd hobbyprojecten en te complexe softwaresystemen.
          | Kies een relevant systeem voor jezelf en een noemenswaardige groep belanghebbenden (community), bijvoorbeeld:
        ul
          li
            p één van je organisatie.
          li
            p
              em desnoods
              |
              | één voor jou al ruim bekend en actief ontwikkeld opensourceproject met een community (zie bijvoorbeeld:
              |
              cite(data-id='6867189/L2HPPLN7')
              cite(data-id='6867189/YD7G37U3')
              | );
        p
          strong 💡 3
          | : Je moet de implementatie heel goed kunnen doorgronden, en dat in korte tijd.
          | Kies een softwaresysteem ontwikkeld in een jou bekende programmeertaal en voor een jou bekend toepassingsdomein.
      component-section
        div(slot='title') In te leveren
        p
          | Neem je presentatie op (met beeld en geluid).
          | Dat kan bijvoorbeeld met
          |
          a(href='https://web.microsoftstream.com/studio') Microsoft Stream
          |
          | binnen de HAN-Office 365-omgeving.
        p
          | Lever je presentatievideo in op
          |
          a(href='https://www.han.nl/onderwijsondersteuning/tools/video-videotoetsing/index.xml') videotoetsing.han.nl
          | .
          |
          | Pas zodra je video op videotoetsing.han.nl staat heb je het officieel ingeleverd.
          | Stuur de videohyperlink door naar je beoordelaars.
          | Deze hyperlink ontvang je per e-mail van videotoetsing.han.nl, na enige wachttijd.
      component-section
        div(slot='title') Beoordeling
        p
          | Zie het
          |
          a(
            href='bron/Beoordelingsmodel%20%C2%B7%20Presentatie%20over%20je%20keuze%20van%20softwaresysteem%20voor%20het%20onderzoek%20(Ass_Pres).pdf') beoordelingsformulier
          | .
          | \(\text{cijfer} = 9 * (\text{punten} / \text{totaal}) + 1\), minimaal 1 en maximaal 10.
          | Voor de weging van dit deeltentamen en overige examineringsinformatie, zie
          |
          a(
            href='https://isas.han.nl/Default.aspx?F=OnderwijsAanbodDetails&Studiejaar=2021&Eigenaar=AIM&OWE=ASD+OP&Back=A&dt=211700997') iSAS
          | .
    component-section
      div(slot='title')
        | Onderzoek naar performance (
        code B_ond_per
        | )
      component-section
        div(slot='title') Beschrijving
        p
          | Je opdracht is het uitvoeren van een onderzoek ten aanzien van performance aan een softwaresysteem.
          | Je opdrachtgever en lezer is een denkbeeldige hoofdarchitect voor het systeem.
          | Het doel van je onderzoek is het vaststellen in hoeverre het systeem voldoet aan redelijke kwaliteitsvereisten te aanzien van performance, en voor zover niet, wat de oplossingsrichting is voor de gevonden knelpunten.
        p
          | Het onderzoek gaat over compleet softwaresysteem.
          | Je beperken tot specifieke modules en microbenchmarking is niet de bedoeling.
          | Wel mag je subsystemen (vaak ≈ grote packages) benoemen, waar je aandacht aan besteed naargelang hun belang voor de qas’en die je meeneemt in je onderzoek.
          | Uiteraard moet je een echte performanceproblemen oplossen en mag je niet alleen constateren dat alles al goed is.
        p Het komt neer op de volgende stappen
        ol
          li
            p Kies een geschikt softwaresysteem.
              | Dit heb je voor de presentatie al gedaan.
          li
            p
              | Achterhaal het architectuurontwerp van het softwaresysteem.
              | Gebruik een zelfgeschreven SAD of een extern SAD.
              | Stel de
              |
              em.term quality attribute requirements (qars) over performance
              |
              | vast van dit softwaresysteem.
              | Vul het SAD desnoods een met ten minste
              |
              em.term quality attribute scenario’s (qas’en) over performance
              |
              | in tabelvorm bevat.
          li
            p Analyseer of deze qas’en behaald worden.
          li
            p Nu je alle informatie hebt verzameld: beantwoord de onderzoeksvragen.
          li
            p Implementeer verbeteringen aan de broncode per qas.
        component-section
          div(slot='title') De vaste inhoud van het onderzoeksrapport
          p
            | Houd
            |
            a(href='https://maken.wikiwijs.nl/156099/1_1_6_Onderzoeksrapport_schrijven__basis_#!page-5769348') de richtlijnen van Saxion voor HBO-i
            |
            | aan, inclusief de
            |
            em exacte structuur
            |
            | qua hoofdstukken en paragrafen.
          component-section
            div(slot='title') Onderzoeksvragen
            p De hoofdvraag is: hoe kunnen alle qas’en van het softwaresysteem behaald worden?
            p
              | Beantwoord eerst de volgende deelvragen
              |
              em per
              |
              | performance-qas:
            ol
              li
                p
                  | Hoe beïnvloedt het gebruik van (standaard)algoritmes en -datastructuren het behalen van deze qas?
              li
                p Hoe beïnvloedt het architectuurontwerp het behalen van deze qas?
              li
                p
                  | Welke verbeteringen aan de broncode zijn aan te raden voor het behalen van deze qas?
          component-section
            div(slot='title') Methoden
            p
              | Je zal vele methoden toepassen, zoals interviews, desk research, broncodeanalyse, algoritmeanalyse, geautomatiseerde performance tests.
              | Verwijs waar mogelijk naar de ICT Research Methods
              |
              cite(data-id='6867189/WWDFSZKG')
              | , zoals de non-functional test.
              | Heb je dus andere onderzoeksmethoden uit de ICT Research Methods toegepast, benoem die dan ook.
            p
              strong 💡Tip 4
              | : Zorg er ook voor dat je alleen broncode hoeft te analyseren geschreven in een programmeertaal waarvoor voldoende hulpmiddelen zijn.
              | Denk aan dit soort tools:
            ul
              li
                p.bron
                  a(href='https://en.wikipedia.org/wiki/List_of_performance_analysis_tools') List of performance analysis tools
                  | .
              li
                p
                  | Microsoft
                  |
                  a(href='https://github.com/Microsoft/ApplicationInspector') Application Inspector
                  | .
          component-section
            div(slot='title') Materialen
            p
              | Beschrijf hoe je de volgende materialen hebt gebruikt (op wat voor manier dan ook):
            ol
              li Alle broncode van alle onderzochte softwaresystemen.
              li Alle testbroncode van alle onderzochte softwaresystemen.
              li
                | Alle bronnen die je gebruikt hebt (denk aan technische documentatie, communicatie van het ontwikkelteam, requirements-gerelateerde informatie vanuit opdrachtgevers).
              li Het SAD.
              li Kwaliteitsvereisten.
              li De qas’en, zowel schriftelijk als in de vorm van geautomatiseerde tests.
          component-section
            div(slot='title') Bronnen
            p
              | Gebruik de IEEE-verwijzingsstijl
              |
              cite(data-id='6867189/36G9SCWF')
              | .
      component-section
        div(slot='title') In te leveren
        p
          | Lever uiteindelijk in op de deadline van je toetsrooster, ingepakt als ZIP-bestand, via iSAS:
        ol
          li Alle opgesomde materialen, voor zover gebruikt/gemaakt.
          li Broncode van prototypes of andere bijlages die je relevant vindt.
          li Je presentatie.
          li Het onderzoeksrapport.
      component-section
        div(slot='title') Beoordeling
        p
          | Zie het
          |
          a(href='bron/Beoordelingsmodel%20%C2%B7%20Onderzoek%20naar%20performance%20(B_ond_per).pdf') beoordelingsformulier
          | .
          | \(\text{cijfer} = 9 * (\text{punten} / \text{totaal}) + 1\), minimaal 1 en maximaal 10.
          | Voor de weging van dit deeltentamen en overige examineringsinformatie, zie
          |
          a(
            href='https://isas.han.nl/Default.aspx?F=OnderwijsAanbodDetails&Studiejaar=2021&Eigenaar=AIM&OWE=ASD+OP&Back=A&dt=211700997') iSAS
          | .
        p
          | Het is van groot belang dat je resultaten reproduceerbaar en je rapportage en broncode begrijpelijk zijn.
          | Pas agressief tools toe die je broncode verbeteren (formatters, linters, static analysis tools), zodat je beoordelaar en jijzelf meteen goed snappen hoe je broncode werkt.
          | Als je je tests/kwaliteitscontroles ook online uitvoert als CI/CD (GitLab CI, GitHub Actions, enzovoort), is het voor je beoordelaar ook sneller duidelijk hoe jouw tests lokaal gedraaid kunnen worden.
